// ----------------------------------------------------------------------------
// RegisterAddresses.h
//
// Authors:
// Peter Polidoro peter@polidoro.io
// ----------------------------------------------------------------------------
#ifndef REGISTER_ADDRESSES_H
#define REGISTER_ADDRESSES_H

namespace RegisterAddresses
{
enum struct AT42QT1060
{
  CHIP_ID = 0,
  VERSION,
  STATUS = 4,
  CALIBRATE = 12,
  RESET,
  DRIFT_OPTION,
  RECALIBRATION_DELAY,
  KEY_DETECT_THRESHOLD,
  LOW_POWER_MODE = 22,
  IO_MASK,
  KEY_MASK,
  ADJACENT_KEY_SUPRESSION_MASK,
  PWM_MASK,
  DETECTION_MASK,
  ACTIVE_LEVEL_MASK,
  USER_OUTPUT_BUFFER,
  DETECTION_INTEGRATOR,
  PWM_LEVEL,	
  KEY_SIGNAL = 40,
  KEY_REFERENCE = 52,
};

enum struct AT42QT1070
{
  CHIP_ID = 0,
  VERSION,
  STATUS,
  KEY_SIGNAL = 4,
  KEY_REFERENCE = 18,
  KEY_DETECT_THRESHOLD = 32,
  KEY_AKS_LEVEL = 39,
  KEY_DETECT_INTEGRATOR = 46,
  FO_MAX_CAL_GUARD_CHANNEL = 53,
  LOW_POWER_MODE,
  MAX_ON_DURATION,
  CALIBRATE,
  RESET,
};

enum struct AT42QT2120
{
  CHIP_ID = 0,
  VERSION,
  STATUS,
  CALIBRATE = 6,
  RESET,
  LOW_POWER_MODE,
  TOWARDS_DRIFT_COMPENSATION_DURATION,
  AWAY_DRIFT_COMPENSATION_DURATION,
  DETECTION_INTEGRATOR,
  RECALIBRATION_DELAY,
  DRIFT_COMPENSATION_HOLD_DURATION,
  SLIDER_OR_WHEEL_ENABLE,
  CHARGE_DURATION,
  KEY_DETECT_THRESHOLD,
  KEY_CONTROL = 28,
  KEY_PULSE_SCALE = 40,
  KEY_SIGNAL = 52,
  KEY_REFERENCE = 76,
};

enum struct AT42QT2160
{
  CHIP_ID = 0,
  VERSION,
  STATUS,
  SUB_REVISION = 7,
  CALIBRATE = 10,
  RESET,
  LOW_POWER_MODE,
  BURST_REPETITION,
  TOWARDS_DRIFT_COMPENSATION_DURATION = 15,
  AWAY_DRIFT_COMPENSATION_DURATION,
  DETECTION_INTEGRATOR,
  RECALIBRATION_DELAY,
  DRIFT_COMPENSATION_HOLD_DURATION,
  SLIDER_CONTROL,
  SLIDER_OPTIONS,
  KEY_CONTROL,
  KEY_DETECT_THRESHOLD = 38,
  KEY_BURST_LENGTH = 54,
  GPIO_GPO_DRIVE = 70,
  GPIO_DIRECTION = 73,
  GPIO_GPO_PWM,
  PWM_LEVEL = 76,
  GPIO_WAKE,
  COMMON_CHANGE_KEYS,
  KEY_SIGNAL = 100,
  KEY_REFERENCE = 132,
};

}
#endif
